StoreStepAddEvalCg <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	
	StoreEvalCgCoeff(step.num, inp.feat.indices)
}

StoreStepAddEvalIgd <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	print(inp.feat.indices)
	
	StoreEvalIgdCoeff(step.num, inp.feat.indices)
}
StoreStepAddEvalAiC <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	
	StoreEvalAiC(step.num, inp.feat.indices)
}

StoreStepAddEvalCv <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	
	StoreEvalCv(step.num, inp.feat.indices)
}

StoreStepDelEvalIgd <- function(step.num) {
	StoreEvalIgdCoeff(step.num)
}

StoreStepDelEvalCg <- function(step.num) {
	StoreEvalCgCoeff(step.num)
}

StoreStepdelEvalCv <- function(step.num) {
	StoreEvalCv(step.num)
}

StoreStepdelEvalAiC <- function(step.num) {
	StoreEvalAiC(step.num)
}


