
source('global.R')
source('plotCorrelation.R')
source('plots.R')


#GetDatasetnames()

id <- GetDatasetId("TelecomVersion1")
fs1 <- AssignFeatureSet(c("DATAVOLUME", "NUMMMSOUT", "NUMVASOUT", "NUMCALLSFIXEDOUT", "DURATIONFIXEDINC", "NUMSMSINTEROUT", "NUMSMSCMPINC", "NUMSMSVASINC"), dataset.id = id)
fs2 <- AssignFeatureSet(c("NUMCALLSFIXEDOUT"), dataset.id = id)
fs3 <- DelFeatureSet(fs1, fs2, dataset.id = id)
fm2 <- CoeffLearner(fs3, "igd", num.iters = 2, dataset.id = id)
fs5 <- StepDel(fs3, "cg", "aic", dataset.id = id)
print(fs5)


SaveSession("TeleomProgramV1", dataset.id = id)

source('global.R')
source('plotCorrelation.R')
source('plots.R')
id <- GetDatasetId("TelecomVersion2")
fs1 <- AssignFeatureSet(c("DATAVOLUME", "NUMMMSOUT", "NUMVASOUT", "NUMCALLSFIXEDOUT", "DURATIONFIXEDINC", "NUMSMSINTEROUT", "NUMSMSCMPINC", "NUMSMSVASINC"), dataset.id = id)
fs2 <- AssignFeatureSet(c("NUMCALLSFIXEDOUT"), dataset.id = id)
fs3 <- DelFeatureSet(fs1, fs2, dataset.id = id)
fm2 <- CoeffLearner(fs3, "igd", num.iters = 2, dataset.id = id)
fs5 <- StepDel(fs3, "cg", "aic", dataset.id = id)
print(fs5)
SaveSession("TeleomProgramV2", dataset.id = id)
