/**
 * Created with IntelliJ IDEA.
 * User: Vamshika
 * Date: 4/20/13
 * Time: 9:45 PM
 * To change this template use File | Settings | File Templates.
 */
public class MyFeatureSubsetAiC extends MyFeatureSubset
{
    public double[]  coefficients;
    public double  likelihood;
    public int initFeatureSubset(String inpString)
    {

        // layout fs1   : feature set indices$coeff values
        String[] splitted  = inpString.split("\\$"); // splits to feature set indices and others
        String[] sFeatureIndices = splitted[0].split(",");
	//SimpleLogger.write("InpString :" + inpString);
	//SimpleLogger.write("Splitted :[0] : " + splitted[0]);
	//SimpleLogger.write("Splitted :[1] : " + splitted[1]);
        String[] sCoef = splitted[1].split(",");

        featureIndices = new int[sFeatureIndices.length];
        coefficients = new double[sFeatureIndices.length];


        for(int i = 0; i < sFeatureIndices.length; i ++)
        {
            featureIndices[i] = Integer.parseInt(sFeatureIndices[i]);
            coefficients[i] = Double.parseDouble(sCoef[i]);

        }

        return 1;
    }
    public String getAiCScore()
    {
        int numFeatures = MyTuple.xVal.length; // num features
        double aic = 0.0;
        aic = 2*numFeatures - 2*Math.log(likelihood);
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i < featureIndices.length; i ++)
        {
            sb.append(featureIndices[i]);
            if(i != featureIndices.length - 1)
            {
                sb.append(",");
            }
        }
        sb.append("$");
        sb.append(aic);
        return sb.toString();
    }


}
