/**
 * Created with IntelliJ IDEA.
 * User: Vamshika
 * Date: 4/20/13
 * Time: 7:38 PM
 * To change this template use File | Settings | File Templates.
 */
public class MyFeatureSubsetCG extends MyFeatureSubset
{
    public double[][] gradientVector;
    public double[][] coefficients;
    public double[] denomWTerm;
    public double[][] uValues;
    public int numFolds;


    public int initFeatureSubset(int k, String inputString)
    {

        // fs1 = featuresetindices$fold1 ~ fold2 ~ fold3 ~ .. foldk
        // fold1 = coefvals!uvector!gradientvector
        numFolds = k;
        String[] splitted = inputString.split("\\$");

        String[] sFeatureSetIndices = splitted[0].split(",");
        int numFeatures = sFeatureSetIndices.length;
        featureIndices = new int[numFeatures];
        coefficients = new double[k][numFeatures];
        denomWTerm = new double[k];
        uValues = new double[k][numFeatures];
        gradientVector = new double[k][numFeatures];

        for(int i = 0; i < numFeatures; i ++)
        {
            featureIndices[i] = Integer.parseInt(sFeatureSetIndices[i]);
        }

        // folds
        String[] sFolds = splitted[1].split("~");
	//SimpleLogger.write("K : " + k + "numFeatures : " + numFeatures);
        for(int i = 0; i < k ; i ++)
        {
            String[] sFoldValues = sFolds[i].split("!");

            // index 0 contains coef values
            // index 1 contains uvector-values
            // index 2 contains gradient values

            String[] sCoef = sFoldValues[0].split(",");
            String[] sUvector = sFoldValues[1].split(",");
            String[] sGradient = sFoldValues[2].split(",");

            for(int j = 0; j < numFeatures; j ++)
            {
	//	SimpleLogger.write("Scoef : " + sCoef[j]);
                coefficients[i][j] = Double.parseDouble(sCoef[j]);
	//	SimpleLogger.write("suVector : " + sUvector[j]);
                uValues[i][j] =  Double.parseDouble(sUvector[j]);
	//	SimpleLogger.write("sGradient : " + sGradient[j]);
                gradientVector[i][j] = Double.parseDouble(sGradient[j]);
            }

        }
	//SimpleLogger.write("Returning");
        return 1;
    }
    public String getCGResult()
    {
        StringBuilder sb = new StringBuilder();
        // res = numFolds$feature set indices$fold1 ~ fold2 ~ fold3 ~ .. foldn
        // fold1 = denomWTerm!gradientVector,

        for(int i = 0; i < featureIndices.length; i ++)
        {
            sb.append(featureIndices[i]);
            if(i != featureIndices.length - 1)
                sb.append(",");
        }
        sb.append("$");
        StringBuilder sbFolds = new StringBuilder();
        for(int i = 0; i < numFolds; i ++)
        {
            sbFolds.append(denomWTerm[i]);
            sbFolds.append("!");
            for(int j = 0; j < gradientVector[i].length; j ++)
            {
                sbFolds.append(gradientVector[i][j]);
                if(j != gradientVector[i].length - 1)
                {
                    sbFolds.append(",");
                }
            }
            if(i != numFolds - 1)
            {
                sbFolds.append("~");
            }
        }
        sb.append(sbFolds.toString());
        return sb.toString();
    }

}
