import java.nio.ByteBuffer;
import java.util.HashMap;

/**
 * Created with IntelliJ IDEA.
 * User: Vamshika
 * Date: 1/30/13
 * Time: 5:33 PM
 * To change this template use File | Settings | File Templates.
 */
public class MyTuple {
    // variable initializations
    public static double xVal[];
    public static double yVal = 1;
    public static int decodeIdx[];
    public static int decodeIdxMap[];
    public static int yIdx;
    public static int yIdxMap;
    public static double recId;
    public static int origNumFeatures;
    public static HashMap<Integer, String> hmNewFeatures;

    //initialize the xVal size
    public static int initAttrVector(int totNumFeatures, int origFeatures, int idx) {
        xVal = new double[totNumFeatures];
        decodeIdxMap = new int[totNumFeatures];
	//SimpleLogger.write(Integer.toString(n));
        yIdx = idx;

        recId = 0;
        origNumFeatures = origFeatures;
        hmNewFeatures = new HashMap<Integer, String>();
        return 0;
    }

    public static String getNewFeatureString(int newFeature)
    {
        Integer key = new Integer(newFeature);
        String retString = null;
        if(hmNewFeatures.containsKey(key))
        {
            retString = hmNewFeatures.get(key);
        }
        return retString;

    }


   public static int initNewFeatures(String s)
   {
       // layout
       // newfeature1~feature1, feature2# newfeature2~ feature1, feature2..
       if(s == null)
	 return 1;
       //SimpleLogger.write("InitNewFeatures (length) : " + s.length());
       if(s.length() == 0)
       {
		return 1; // nothing to be done
       }
       String splitted[] = s.split("#");
       for(int i = 0; i < splitted.length; i ++)
       {
           String tmp = splitted[i];
           String sTmpSplitted[] = tmp.split("~");
           Integer key = new Integer(sTmpSplitted[0]);
           hmNewFeatures.put(key, sTmpSplitted[1]);
       }
       return 1;
   }
    // set the decode indices
    public static int setDecodeIndices(String s) {
        //schema : index1, index2, index3,...index n                                        i
	//SimpleLogger.write(s); // write to the file
        String splitted[]  = s.split(",");
        decodeIdx = new int[splitted.length];
        for(int i = 0; i < splitted.length; i++ ) {
            MyTuple.decodeIdx[i] = Integer.valueOf(splitted[i]);
        }
        return 0;
    }

      // set decode index map
    public static int setDecodeIndicesMap(String s) {
        // schema : index1.from.orig.dataset,index2.from.orig.dataset,...,indexn.from.orig.dataset#mappedIndex1.from.new.dataset,..., mappedIndexn.from.new.dataset
        String splitted[] = s.split("#");
        String origStrIndex[] = splitted[0].split(",");
        String mapStrIndex[] = splitted[1].split(",");

        int idx1, idx2;
        for(int i = 0; i < origStrIndex.length; i ++) {
            idx1 = new Integer(origStrIndex[i]).intValue();
            idx2 = new Integer(mapStrIndex[i]).intValue();
            decodeIdxMap[idx1] = idx2;
        }
        return 0;
    }

    public static int setYIdx(String s) {
        // schema:yIdx
        yIdx = new Integer(s).intValue();
	//SimpleLogger.write("~~~~~");
	//SimpleLogger.write("YIdx : " + yIdx);
	//SimpleLogger.write("~~~~~");
        return 0;
    }
    public static double toDouble(byte[] bytes) {
        return ByteBuffer.wrap(bytes).getDouble();
    }

    public static void decode(byte[] b) {
        int bx;
        long bbits;
        byte[] tmp;
        tmp = new byte[8];

        for(int i = 0; i < decodeIdx.length; i++){
            bbits = 0;
            for(bx = 0; bx < 8; bx ++) {
                bbits |= (long) (b[8 * decodeIdx[i] + bx] & 0xff) << (8 * bx);
            }
            xVal[ decodeIdx[i] ] = Double.longBitsToDouble(bbits);
        }
        yVal = (b[8 * yIdx] == 1)?1.0 : -1.0;
       
        recId ++;
    }

    public static void print() {
        StringBuilder sbPrint = new StringBuilder();
        sbPrint.append("(");
        for(int i = 0; i < decodeIdx.length; i++) {
            sbPrint.append(decodeIdx[i]+ " : " + xVal[decodeIdx[i]]);
            if(i != decodeIdx.length - 1)
                sbPrint.append(",");
        }
        sbPrint.append(")");
        //SimpleLogger.write(sbPrint.toString());
    }



    // helper functions may or may not be used.
    public static double getX(int idx) {
        return xVal[idx];
    }
    public static double getY(int idx) {
        return yVal;
    }

}
