source('init.R')
source('manual.R')
source('descstats.R')
source('mdbutilities.R')
source('datalayer_delegator.R')
source('datalayer_oracledb.R')
source('skel_manual.R')
source('exe_manual.R')
source('skel_descstats.R')
source('skel_exploratory.R')
source('exe_descstats_corr.R')
source('exe_descstats_coef.R')
source('exe_descstats_eval.R')
source('exe_descstats_expl.R')
source('exe_utilities.R')
source('exploratory.R')


f1 <- AssignFeatureSet(c(1,2,3,4), 1)
#print(f1)
f2 <- AssignFeatureSet(c(5), 1)
l1 <- CoeffLearner(f1, "igd", 1, num.iters=2, init.wt=0.1)
f3 <- BestK(l1, k.val = 3, dataset.id = 1)
l2 <- Evaluate(f3, "cg", "aic", 1, num.iters=1, num.folds=1)
f4 <- StepDel(f3, "cg", "cv", dataset.id = 1, num.folds = 5)

node.list <- GenNodeList(1)
updated.nodelist <- UpdateLevels(node.list, 1)


#f2 <- AssignFeatureSet(c(5,6,7), 1)
#print(f2)
#f3 <- AddFeatureSet(f1, f2, 1)
#print(f3)
#f4 <- DelFeatureSet(f3, f1, 1)
##print(f4)
#f5 <- IntersectFeatureSet(f3, f2, 1)
#print(f5)
#f6 <- CreateFeature(1, 3, 1)
#print(f6)
#l1 <- CorrelationX(f1, 1)
#print(l1)
#print('Pradap')
#l2 <- CorrelationY(f1, f2, 1)
#print(l2)
#l1 <- Evaluate(f1, "cg", "aic", 1, num.iters=1, num.folds=1)
#s1 <- StepAdd(f1, f2, "igd", "cv", 1, num.folds = 5)
#s1 <- StepDel(f1, "cg", "cv", dataset.id = 1, num.folds = 5)

